
#include "HEAD.h"

#include "node.h"

#include "visitprocs.h"

#include "gsdescr.h"

#include <stdlib.h>

#include "obstack.h"

static struct obstack TreeSpace;

char* TreeNodeAlloc(size) int size;

{return (obstack_alloc(&TreeSpace, size));}

void InitTree() { obstack_init(&TreeSpace); }

NODEPTR Mklitstring(_coordref,_tr1)
POSITION *_coordref;
SYMB _tr1;
{
_TSPlitstring n;
n = (_TSPlitstring) TreeNodeAlloc (sizeof (struct _TSlitstring));
n->_pos = *_coordref;

n->_ATstrval=_tr1;
return ((NODEPTR) n);
}

NODEPTR Mkident(_coordref,_tr1)
POSITION *_coordref;
SYMB _tr1;
{
_TSPident n;
n = (_TSPident) TreeNodeAlloc (sizeof (struct _TSident));
n->_pos = *_coordref;

n->_ATidval=_tr1;
return ((NODEPTR) n);
}

NODEPTR Mkaxiom(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPaxiom n;
n = (_TPPaxiom) TreeNodeAlloc (sizeof (struct _TPaxiom));
n->_proc =_VS1axiom;
n->_pos = *_coordref;
n->_desc1= (_TSPparams)_tr1;
return ( (NODEPTR) n);
}

NODEPTR Mkparams_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPparams_1 n;
n = (_TPPparams_1) TreeNodeAlloc (sizeof (struct _TPparams_1));
n->_proc =_VS1params_1;
n->_pos = *_coordref;
n->_desc1= (_TSPparam)_tr1;
return ( (NODEPTR) n);
}

NODEPTR Mkparams_2(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPparams_2 n;
n = (_TPPparams_2) TreeNodeAlloc (sizeof (struct _TPparams_2));
n->_proc =_VS1params_2;
n->_pos = *_coordref;
n->_desc1= (_TSPparam)_tr1;
n->_desc2= (_TSPparams)_tr2;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPparam_1 n;
n = (_TPPparam_1) TreeNodeAlloc (sizeof (struct _TPparam_1));
n->_proc =_VS1param_1;
n->_pos = *_coordref;
n->_desc1= (_TSPlitstring)_tr1;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_2(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPparam_2 n;
n = (_TPPparam_2) TreeNodeAlloc (sizeof (struct _TPparam_2));
n->_proc =_VS1param_2;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPlitstring)_tr2;
n->_desc3= (_TSPoptlitstring)_tr3;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_3(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPparam_3 n;
n = (_TPPparam_3) TreeNodeAlloc (sizeof (struct _TPparam_3));
n->_proc =_VS1param_3;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPlitstring)_tr2;
n->_desc3= (_TSPoptlitstring)_tr3;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_4(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPparam_4 n;
n = (_TPPparam_4) TreeNodeAlloc (sizeof (struct _TPparam_4));
n->_proc =_VS1param_4;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPrope)_tr2;
n->_desc3= (_TSPoptlitstring)_tr3;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_5(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPparam_5 n;
n = (_TPPparam_5) TreeNodeAlloc (sizeof (struct _TPparam_5));
n->_proc =_VS1param_5;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPrope)_tr2;
n->_desc3= (_TSPoptlitstring)_tr3;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_6(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPparam_6 n;
n = (_TPPparam_6) TreeNodeAlloc (sizeof (struct _TPparam_6));
n->_proc =_VS1param_6;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPrope)_tr2;
n->_desc3= (_TSPoptlitstring)_tr3;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_7(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPparam_7 n;
n = (_TPPparam_7) TreeNodeAlloc (sizeof (struct _TPparam_7));
n->_proc =_VS1param_7;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPrope)_tr2;
n->_desc3= (_TSPoptlitstring)_tr3;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_8(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPparam_8 n;
n = (_TPPparam_8) TreeNodeAlloc (sizeof (struct _TPparam_8));
n->_proc =_VS1param_8;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPoptlitstring)_tr2;
return ( (NODEPTR) n);
}

NODEPTR Mkparam_9(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPparam_9 n;
n = (_TPPparam_9) TreeNodeAlloc (sizeof (struct _TPparam_9));
n->_proc =_VS1param_9;
n->_pos = *_coordref;
n->_desc1= (_TSPname)_tr1;
n->_desc2= (_TSPoptlitstring)_tr2;
return ( (NODEPTR) n);
}

NODEPTR Mkname_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPname_1 n;
n = (_TPPname_1) TreeNodeAlloc (sizeof (struct _TPname_1));
n->_proc =_VS1name_1;
n->_pos = *_coordref;
n->_desc1= (_TSPident)_tr1;
return ( (NODEPTR) n);
}

NODEPTR Mkrope_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPrope_1 n;
n = (_TPPrope_1) TreeNodeAlloc (sizeof (struct _TPrope_1));
n->_proc =_VS1rope_1;
n->_pos = *_coordref;
n->_desc1= (_TSPlitstring)_tr1;
return ( (NODEPTR) n);
}

NODEPTR Mkrope_2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPrope_2 n;
n = (_TPPrope_2) TreeNodeAlloc (sizeof (struct _TPrope_2));
n->_proc =_VS1rope_2;
n->_pos = *_coordref;
n->_desc1= (_TSPlitstring)_tr1;
return ( (NODEPTR) n);
}

NODEPTR Mkoptlitstring_1(_coordref)
POSITION *_coordref;
{_TPPoptlitstring_1 n;
n = (_TPPoptlitstring_1) TreeNodeAlloc (sizeof (struct _TPoptlitstring_1));
n->_proc =_VS1optlitstring_1;
n->_pos = *_coordref;
return ( (NODEPTR) n);
}

NODEPTR Mkoptlitstring_2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPoptlitstring_2 n;
n = (_TPPoptlitstring_2) TreeNodeAlloc (sizeof (struct _TPoptlitstring_2));
n->_proc =_VS1optlitstring_2;
n->_pos = *_coordref;
n->_desc1= (_TSPlitstring)_tr1;
return ( (NODEPTR) n);
}

#ifndef GETlitstringstrval
#define GETlitstringstrval(x) (x)
#endif

#ifndef GETidentidval
#define GETidentidval(x) (x)
#endif

void SourceLeaf(d) GRUNDSYMBOLDESKRIPTOR *d;
{_incrnodestack ();
switch (d->SyntaxCode) {

case 2: _nst[_nsp] =Mklitstring(&(d->Pos),GETlitstringstrval (d->Attr)); break;

case 3: _nst[_nsp] =Mkident(&(d->Pos),GETidentidval (d->Attr)); break;
}}


